import java.awt.*; 
import java.awt.event.*; 
import java.applet.Applet;

public class PopupMenuDemo extends Applet{ 
	  Button b; 
	  TextField msg; 
	  PopupAppMenu m; 
	  public PopupMenuDemo(){ 
		  setSize(200, 200); 
		  b = new Button("Pop-up Menu"); 
		  add(b, BorderLayout.NORTH); 
		  msg = new TextField(); 
		  msg.setEditable(false); 
		  add(msg, BorderLayout.SOUTH); 
		  m = new PopupAppMenu(this); 
		  add(m); 
		  b.addActionListener(new ActionListener(){ 
			  public void actionPerformed(ActionEvent e){ 
				  m.show(b, 20, 20); 
				  } 
	}); 
	addMouseListener(new MouseAdapter(){ 
		public void mousePressed(MouseEvent e){ 
			if (e.isPopupTrigger()) 
			  m.show(e.getComponent(), e.getX(), e.getY()); 
		  } 
		  public void mouseReleased(MouseEvent e){ 
			if (e.isPopupTrigger()) 
			  m.show(e.getComponent(), e.getX(), e.getY()); 
		  } 
		}); 
	  } 
	  public static void main(String[] args){ 
		PopupMenuDemo app = new PopupMenuDemo(); 
		app.setVisible(true); 
	  } 
	} 
	 
	class PopupAppMenu extends PopupMenu 
		implements ActionListener{ 
	  PopupMenuDemo ref; 
	  public PopupAppMenu(PopupMenuDemo ref){ 
		super("File"); 
		this.ref = ref; 
		MenuItem mi; 
		add(mi = new MenuItem("Copy")); 
		mi.addActionListener(this); 
		add(mi = new MenuItem("Open")); 
		mi.addActionListener(this); 
		add(mi = new MenuItem("Cut")); 
		mi.addActionListener(this); 
		add(mi = new MenuItem("Paste")); 
		mi.addActionListener(this); 
	  } 
	  public void actionPerformed(ActionEvent e){ 
		String item = e.getActionCommand(); 
		ref.msg.setText("Option Selected: " + item); 
	  } 
	} 